package abc.ar.ast;

import java.util.List;

import polyglot.types.Flags;
import polyglot.util.Position;
import abc.aspectj.ast.AspectBody;
import abc.aspectj.ast.PerClause;
import abc.aspectj.visit.ContainsAspectInfo;

public class AspectRefinementDecl_c extends RefinableAspectDecl_c implements
		AspectRefinementDecl, ContainsAspectInfo{

	private String _originalAspectName;
	
	public AspectRefinementDecl_c(Position pos, boolean is_privileged,
			Flags flags, String name, /*TypeNode superClass,*/ List interfaces,
			PerClause per, AspectBody body, String featureName) {
		
		super(pos, is_privileged, flags, name+"$R$"+featureName, null/*superClass*/, interfaces, per,
				body);
		_originalAspectName=name;
	}

	public String getOriginalName() {
		return _originalAspectName;
	}

//	public void update(GlobalAspectInfo gai, Aspect current_aspect) {
//		super.update(gai, current_aspect);
//		
//		Refinement refinement = new Refinement(position());
//		
//		refinement.setAspectDecl(this);
//		refinement.setParentDecl(_refinedAspect);
//		
//		if (Debug.v().aspectRefinement) System.out.println("addAspectRefinement("+refinement+")");
//		((ARGlobalAspectInfo)gai).addAspectRefinement(refinement);
//	}
}
