package abc.ar.weaving.weaver.around;

import java.util.List;

import soot.SootClass;
import soot.SootMethod;
import abc.ar.weaving.aspectinfo.NamedAdviceDecl;
import abc.soot.util.LocalGeneratorEx;
import abc.weaving.aspectinfo.AdviceDecl;
import abc.weaving.matching.AdviceApplication;
import abc.weaving.weaver.around.AdviceMethod;
import abc.weaving.weaver.around.AroundWeaver;

public class ARAroundWeaver extends AroundWeaver {

	protected AdviceMethod newAdviceMethod(AroundWeaver weaver, SootMethod method, AdviceDecl adviceDecl,
			List sootLocalAdviceMethods, AdviceApplication adviceAppl) {
		String name = null;
		if (adviceAppl.advice instanceof NamedAdviceDecl)
			name = ((NamedAdviceDecl) adviceAppl.advice).getName();
		ARAdviceMethod r = new ARAdviceMethod(weaver, method, AdviceMethod.getOriginalAdviceFormals(adviceDecl),
				sootLocalAdviceMethods, name);
		r.init();
		return r;
	}
}
