package abc.ar.weaving.weaver.around;

import soot.SootClass;
import soot.SootMethod;
import abc.weaving.matching.AdviceApplication;
import abc.weaving.weaver.around.AdviceApplicationInfo;
import abc.weaving.weaver.around.AdviceMethod;
import abc.weaving.weaver.around.AroundWeaver;
import abc.weaving.weaver.around.ProceedMethod;

public class ARProceedMethod extends ProceedMethod {

	ARProceedMethod(AdviceMethod method, SootClass shadowClass, boolean bStaticProceedMethod, String proceedMethodName,
			boolean bClosureMethod) {
		super(method, shadowClass, bStaticProceedMethod, proceedMethodName, bClosureMethod);
	}

	protected AdviceApplicationInfo newAdviceApplicationInfo(AroundWeaver aroundWeaver2, ProceedMethod method,
			AdviceApplication adviceAppl, SootMethod shadowMethod) {
		return new ARAdviceApplicationInfo(aroundWeaver2, method, adviceAppl, shadowMethod);
	}
}
