package abc.ar.weaving.weaver.around;

import soot.SootClass;
import soot.SootMethod;
import abc.weaving.weaver.around.AdviceLocalClass;
import abc.weaving.weaver.around.AdviceLocalMethod;
import abc.weaving.weaver.around.AdviceMethod;

public class ARAdviceLocalClass extends AdviceLocalClass {

	private String adviceName;

	public ARAdviceLocalClass(AdviceMethod method, SootClass sootClass, String adviceName) {
		super(method, sootClass);
		this.adviceName=adviceName;
	}

	public void addAdviceLocalMethod(SootMethod m) {
		this.adviceLocalMethods.add(new ARAdviceLocalMethod(this, adviceMethod, m, adviceName));
	}

	protected AdviceLocalMethod newAdviceLocalMethod(AdviceLocalClass class1, AdviceMethod adviceMethod2, SootMethod m) {
		return new ARAdviceLocalMethod(class1, adviceMethod2, m, adviceName);
	}
}
